%MACRO R02X78H1; 
%***********************************************************************
************************************************************************

  MACRO NAME:    R02X78H1
  PURPOSE:       RXHCC hierarchies for RXHCCs that are included
                 in software
  COMMENT:       it is assumed that:
                  -MAX number of RXCCs are placed into global macro 
                   variable N_RX in the main macro
                  -the following arrays are set in the main macro
                   ARRAY R(&N_RX)  RXCC1-RXCC&N_RX
                   ARRAY RX(&N_RX) RXHCC1-RXHCC&N_RX
                  -format ICD to RXCC creates only 78 out of &N_RX CMS
                   RXCCs

***********************************************************************;
 %* set to 0 RXHCCs in HIER parameter - taken from software hierarchy 
    variable;
 %MACRO SET0(CC=, HIER= );
     IF RXHCC&CC=1 THEN DO I = &HIER; RX(I) = 0; END;
 %MEND SET0;

 %*to copy RXCC into RXHCC;
  DO K=1 TO &N_RX;
     RX(K)=R(K);
  END;

 %*imposing hierarchies;
 /*Neoplasm 1 */   %SET0(CC=8  ,HIER=%STR(9,10,11,48,50 ));
 /*Neoplasm 2 */   %SET0(CC=9  ,HIER=%STR(10,11,48,50 ));
 /*Neoplasm 3 */   %SET0(CC=10 ,HIER=%STR(11 ));
 /*Diabetes 1 */   %SET0(CC=14 ,HIER=%STR(15 ));
 /*Metabolic 1 */  %SET0(CC=18 ,HIER=%STR(19 ));
 /*GI 1 */         %SET0(CC=30 ,HIER=%STR(31 ));
 /*MSK 3 */        %SET0(CC=40 ,HIER=%STR(41,42,147 ));
 /*MSK 4 */        %SET0(CC=41 ,HIER=%STR(42 ));
 /*Blood 1 */      %SET0(CC=47 ,HIER=%STR(50 ));
 /*Blood 2 */      %SET0(CC=48 ,HIER=%STR(50 ));
 /*Cognitive 2 */  %SET0(CC=54 ,HIER=%STR(55 ));
 /*Psychiatric 1 */%SET0(CC=58 ,HIER=%STR(59,60,61,62,63,65,66,67,68 ));
 /*Psychiatric 2 */%SET0(CC=59 ,HIER=%STR(60,61,62,63 ));
 /*Psychiatric 3 */%SET0(CC=60 ,HIER=%STR(61,62,63 ));
 /*Psychiatric 4 */%SET0(CC=61 ,HIER=%STR(62,63 ));
 /*Psychiatric 5 */%SET0(CC=62 ,HIER=%STR(63 ));
 /*DD 1 */         %SET0(CC=65 ,HIER=%STR(61,62,63,66,67,68 ));
 /*DD 2 */         %SET0(CC=66 ,HIER=%STR(67,68 ));
 /*DD 3 */         %SET0(CC=67 ,HIER=%STR(68 ));
 /*Neuro 9 */      %SET0(CC=78 ,HIER=%STR(79,80 ));
 /*Neuro 10 */     %SET0(CC=79 ,HIER=%STR(80 ));
 /*Heart 1 */      %SET0(CC=86 ,HIER=%STR(87,88 ));
 /*Heart 2 */      %SET0(CC=87 ,HIER=%STR(88 ));
 /*Lung 1 */       %SET0(CC=103,HIER=%STR(104,105 ));
 /*Lung 2 */       %SET0(CC=104,HIER=%STR(105 ));
 /*Kidney 1 */     %SET0(CC=120,HIER=%STR(121,122,123,124,125,126,168 ));
 /*Kidney 2 */     %SET0(CC=121,HIER=%STR(122,123,124,125,126 ));
 /*Kidney 3 */     %SET0(CC=122,HIER=%STR(123,124,125,126 ));
 /*Kidney 4 */     %SET0(CC=123,HIER=%STR(124,125,126 ));
 /*Kidney 5 */     %SET0(CC=124,HIER=%STR(125,126 ));
 /*Kidney 6 */     %SET0(CC=125,HIER=%STR(126 ));
 /*Transplant 1 */ %SET0(CC=166,HIER=%STR(167,168 ));
 /*Transplant 2 */ %SET0(CC=167,HIER=%STR(168 ));

%MEND R02X78H1;
