set more off
set rmsg on

cd /disk/agedisk3/medicare.work/finkels-DUA22559/tangb/contract_design/code/RiskScoreOutputs

global input /disk/agedisk3/medicare.work/finkels-DUA22559/tangb/contract_design/code/RiskScoreOutputs
global outputs /disk/agedisk3/medicare.work/finkels-DUA22559/tangb/contract_design/code/RiskScoreOutputs
global partab_input /disk/agedisk3/medicare.work/finkels-DUA22559/tangb/contract_design/code/RiskScoreOutputs/MedicarePartsAandB
global temp /disk/agedisk3/medicare.work/finkels-DUA22559/tangb/contract_design/temp
global bene_xwalk /disk/agedisk5/medicare/afinkels-DUA22559/medipd/data/20pct/ben/xwalk20174_16702

* switches 
scalar risk_score == 1 
scalar partab == 1 

if risk_score == 1 {
set more off

* set the location of the outputs from the SAS programs here: 

cd /disk/agedisk3/medicare.work/finkels-DUA22559/tangb/contract_design/code/RiskScoreOutputs

global input /disk/agedisk3/medicare.work/finkels-DUA22559/tangb/contract_design/code/RiskScoreOutputs
global outputs /disk/agedisk3/medicare.work/finkels-DUA22559/tangb/contract_design/code/RiskScoreOutputs
global temp /disk/agedisk3/medicare.work/finkels-DUA22559/tangb/contract_design/temp
global bene_xwalk /disk/agedisk5/medicare/afinkels-DUA22559/medipd/data/20pct/ben/xwalk20174_16702

forv y = 2006/2010 {

use ${input}/rxhcc_riskscore_`y', clear
cap drop yr
gen yr = `y'+1

cap rename BENE_ID bene_id
rename SCORE_CE_NonLowInc_Aged riskscore_CE
rename SCORE_NE_NonLowInc_Community riskscore_NE
keep bene_id yr riskscore* RXHCC*

save ${temp}/rxhcc_riskscore_`y'_clean, replace

} 

* CE for Baseline
use ${temp}/rxhcc_riskscore_2006_clean, clear
append using ${temp}/rxhcc_riskscore_2007_clean ${temp}/rxhcc_riskscore_2008_clean 

merge m:1 bene_id using ${bene_xwalk}, gen(_dua_bene2)
replace bene_id20174=bene_id if bene_id20174==""
drop bene_id
rename bene_id20174 bene_id

keep bene_id yr RXHCC* riskscore_CE riskscore_NE

save ${outputs}/RiskScores_baseline, replace

* CE for 65
forv y = 2008/2010 {

use ${temp}/rxhcc_riskscore_`y'_clean, clear
cap drop yr
gen yr = `y'-1

save ${temp}/rxhcc_riskscore_`y'_CEfor65, replace

} 

use ${temp}/rxhcc_riskscore_2008_CEfor65, clear
append using ${temp}/rxhcc_riskscore_2009_CEfor65 ${temp}/rxhcc_riskscore_2010_CEfor65 

merge m:1 bene_id using ${bene_xwalk}, gen(_dua_bene2)
replace bene_id20174=bene_id if bene_id20174==""
drop bene_id
rename bene_id20174 bene_id

keep bene_id yr RXHCC* riskscore_CE

save ${outputs}/RiskScores_CEfor65, replace


* NE for 65
forv y = 2007/2009 {

use ${temp}/rxhcc_riskscore_`y'_clean, clear
cap drop yr
gen yr = `y'

save ${temp}/rxhcc_riskscore_`y'_NEfor65, replace

} 

use ${temp}/rxhcc_riskscore_2007_NEfor65, clear
append using ${temp}/rxhcc_riskscore_2008_NEfor65 ${temp}/rxhcc_riskscore_2009_NEfor65 

merge m:1 bene_id using ${bene_xwalk}, gen(_dua_bene2)
replace bene_id20174=bene_id if bene_id20174==""
drop bene_id
rename bene_id20174 bene_id

keep bene_id yr riskscore_NE

save ${outputs}/RiskScores_NEfor65, replace


* MA RISK SCORES
forv y = 2006/2010 {

use ${input}/mahcc_riskscore_`y', clear
cap drop yr
gen yr = `y'+1

cap rename BENE_ID bene_id
rename SCORE_COMMUNITY riskscore_MA
keep bene_id yr riskscore* HCC*

save ${temp}/mahcc_riskscore_`y'_clean, replace

} 

* CE for Baseline
use ${temp}/mahcc_riskscore_2006_clean, clear
append using ${temp}/mahcc_riskscore_2007_clean ${temp}/mahcc_riskscore_2008_clean 

merge m:1 bene_id using ${bene_xwalk}, gen(_dua_bene2)
replace bene_id20174=bene_id if bene_id20174==""
drop bene_id
rename bene_id20174 bene_id

keep bene_id yr HCC* riskscore_MA

save ${outputs}/MA_riskScores_baseline, replace


}

if partab==1  {

forv year = 2006/2010 {

* CODING IP VISITS
if `year' == 2006 {
	use ${partab_input}/ipvisits`year', clear
	gen admit_mo = month(FROM_DT)
	replace er = er>0 & er!=.
}

if `year'!=2006{
	use ${partab_input}/medpar_ipvisits`year', clear
	if `year' == 2010 { 
		rename er_amt ER_AMT 
	}
	gen admit_mo = month(admsndt)
	gen er = ER_AMT>0 & ER_AMT!=.
	if `year' !=2010 {
	rename BENE_ID bene_id
	}
}

gen ip_admits_tot = 1

gen er_mo = admit_mo*er

forv mo = 1/12 {
	gen ip_admits_mo`mo' = 0
	replace ip_admits_mo`mo' = 1 if admit_mo==`mo'
	gen er_ip_admits_mo`mo' = 0
	replace er_ip_admits_mo`mo' = 1 if er_mo == `mo'
}

collapse (sum) ip_admits* er_ip_admits*, by(bene_id)

tempfile ipvisits
save `ipvisits'

* CODING OP VISITS
use ${partab_input}/opvisits`year', clear

drop A*
cap rename from_dt FROM_DT
gen admit_mo = month(FROM_DT)
gen op_admits_tot = 1
gen er_mo = admit_mo*er
cap rename BENE_ID bene_id

forv mo = 1/12 {
	gen op_admits_mo`mo' = 0
	replace op_admits_mo`mo' = 1 if admit_mo==`mo'
	gen er_op_admits_mo`mo' = 0
	replace er_op_admits_mo`mo' = 1 if er_mo == `mo'
}

collapse (sum) op_admits* er_op_admits*, by(bene_id)

merge 1:1 bene_id using `ipvisits', gen(_merge_op_ip_`year')

foreach var of varlist ip* er* op* {
	replace `var' = 0 if `var' == .
}

save ${partab_input}/hospvisits_`year', replace

} // end year


forv year = 2007/2009 {

local year_tplus1 = `year'+1

use ${partab_input}/hospvisits_`year', clear

keep bene_id op_admits_mo1-op_admits_mo6 er_op_admits_mo1-er_op_admits_mo6 ///
	ip_admits_mo1-ip_admits_mo6 er_ip_admits_mo1-er_ip_admits_mo6

tempfile year_t	
save `year_t'

use ${partab_input}/hospvisits_`year_tplus1', clear

keep bene_id op_admits_mo7-op_admits_mo12 er_op_admits_mo7-er_op_admits_mo12 ///
	ip_admits_mo7-ip_admits_mo12 er_ip_admits_mo7-er_ip_admits_mo12

merge 1:1 bene_id using `year_t', gen(_merge_`year'_`year_tplus1')

gen yr = `year'

save ${partab_input}/hospvisits_tomerge_`year', replace

}

use ${partab_input}/hospvisits_tomerge_2007, clear
	append using ${partab_input}/hospvisits_tomerge_2008 ///
		${partab_input}/hospvisits_tomerge_2009
		
merge m:1 bene_id using ${bene_xwalk}, gen(_dua_bene)

drop if _dua_bene==2
replace bene_id20174=bene_id if bene_id20174==""
drop bene_id
rename bene_id20174 bene_id
		
save ${partab_input}/utilization_tomerge, replace

}


scalar death_dates = 1
if death_dates==1 {

forv year = 2007/2010 {

use ${partab_input}/death_`year', clear

duplicates drop

replace death_dt_medpar = death_dt_bene if death_dt_bene<death_dt_medpar
replace death_dt_bene = death_dt_medpar if death_dt_medpar<death_dt_bene
assert death_dt_bene == death_dt_medpar
drop death_dt_bene
rename death_dt_medpar death_dt_`year'

cap rename BENE_ID bene_id

sort bene_id death_dt_`year'
bysort bene_id: gen obs = _n
keep if obs==1
keep bene_id death_dt_`year'

save ${partab_input}/death_int_`year', replace

} 

use ${partab_input}/death_int_2007, clear
forv year = 2008/2010 {
	merge 1:1 bene_id using ${partab_input}/death_int_`year', gen(_merge_death_`year')
}

gen die = 1
	replace die = 0 if death_dt_2007==. & death_dt_2008==. & death_dt_2009==. & death_dt_2010==.

* Want to keep only one death date
	* We will keep the earliest by rule
egen death_dt = rowmin(death_dt_*)
format death_dt %td

keep bene_id death_dt die

merge m:1 bene_id using ${bene_xwalk}, gen(_dua_bene)

drop if _dua_bene==2
replace bene_id20174=bene_id if bene_id20174==""
drop bene_id
rename bene_id20174 bene_id

save ${partab_input}/death_dates_full, replace

}



